#setwd("C:/Users/idlew/Documents/Courses/ES")
setwd("/Users/patrickboily/Dropbox/Apps/ShareLaTeX/uOttawa - Teaching/Current/mat3777-2022")
library(tidyverse)

gapminder = read.csv("Data/gapminder.csv")
str(gapminder)

gapminder.EPG <- gapminder %>% 
  filter(year==2011) %>%
  select(life_expectancy, region)

#gapminder.EPG[,]
summary(gapminder.EPG,22)
str(gapminder.EPG)

ggplot(data=gapminder.EPG, aes(x=life_expectancy, y=region, fill=region)) +
  geom_point(col="black", alpha=.2,pch=22) + 
  theme(legend.title = element_blank(), legend.position="none")

regions = unique(gapminder.EPG[,"region"])

# Premier échantillon
set.seed(1234)
M=length(regions)
m=8
(sample.reg = sample(1:M,m, replace=FALSE))
(sample.ind = gapminder.EPG$region %in% regions[sample.reg])

(gapminder.EPG.n = gapminder.EPG[sample.ind,])

gapminder.EPG.n$region <- as.factor(gapminder.EPG.n$region)

sommaire = gapminder.EPG.n %>% 
  group_by(region) %>%
  summarise(N=n(), y.barre=mean(life_expectancy), total.y=sum(life_expectancy))

sommaire.final = sommaire %>%
  summarise(somme.N = sum(N), moy.N = mean(N), y.barre.barre = mean(total.y), somme.y.barre = sum(total.y))

# estimateur par grappe 
est.y.barre.G = sommaire.final$somme.y.barre / sommaire.final$somme.N

# quantites intermediaires pour le calcul de la variance d'echantillonnage
s2.Y = var(sommaire$total.y)
s2.N = var(sommaire$N)
rho = cor(sommaire$N,sommaire$total.y)

# variance d'echantillonnage
V.est.y.G = 1/sommaire.final$moy.N^2*1/m*(1-m/M)*(s2.Y+s2.N*est.y.barre.G^2-2*est.y.barre.G*rho*sqrt(s2.N*s2.Y))

# marge d'erreur d'estimation
B= 2*sqrt(V.est.y.G)

# intervalle de confiance a 95%
est.y.barre.G-B
est.y.barre.G+B

# second echantillon
set.seed(12345)
M=length(regions)
m=8
(sample.reg = sample(1:M,m, replace=FALSE))
(sample.ind = gapminder.EPG$region %in% regions[sample.reg])

(gapminder.EPG.n = gapminder.EPG[sample.ind,])

gapminder.EPG.n$region <- as.factor(gapminder.EPG.n$region)

sommaire = gapminder.EPG.n %>% 
  group_by(region) %>%
  summarise(N=n(), y.barre=mean(life_expectancy), total.y=sum(life_expectancy))

sommaire.final = sommaire %>%
  summarise(somme.N = sum(N), moy.N = mean(N), y.barre.barre = mean(total.y), somme.y.barre = sum(total.y))

est.y.barre.G = sommaire.final$somme.y.barre / sommaire.final$somme.N

s2.Y = var(sommaire$total.y)
s2.N = var(sommaire$N)
rho = cor(sommaire$N,sommaire$total.y)

V.est.y.G = 1/sommaire.final$moy.N^2*1/m*(1-m/M)*(s2.Y+s2.N*est.y.barre.G^2-2*est.y.barre.G*rho*sqrt(s2.N*s2.Y))

B= 2*sqrt(V.est.y.G)

est.y.barre.G-B
est.y.barre.G+B

#### Population totale

gapminder.EPG.pop <- gapminder %>% 
  filter(year==2011) %>%
  select(population, region) %>% 
  filter(population < 500000000)

(sum(gapminder.EPG.pop$population))

ggplot(data=gapminder.EPG.pop, aes(x=population, y=region, fill=population)) +
  geom_point(col="black", alpha=.2,pch=22) + 
  theme(legend.title = element_blank(), legend.position="none")

sommaire.pop = gapminder.EPG.pop %>% 
  group_by(region) %>%
  summarise(N=n(), y.pop=mean(population), tau.pop=sum(population))

ggplot(data=sommaire.pop, aes(x=y.pop, y=region, fill=y.pop)) +
  geom_point(col="black", alpha=.2,pch=22) + 
  theme(legend.title = element_blank(), legend.position="none")

regions = unique(gapminder.EPG.pop[,"region"])

# Premier échantillon
set.seed(2) # replicabilite
M=length(regions)
N=nrow(gapminder.EPG.pop)
m=8
(sample.reg = sample(1:M,m, replace=FALSE))
sample.ind = gapminder.EPG.pop$region %in% regions[sample.reg]

(gapminder.EPG.T = gapminder.EPG.pop[sample.ind,])

gapminder.EPG.T$region <- as.factor(gapminder.EPG.T$region)

# statistiques de l'echantillon
(sommaire.T = gapminder.EPG.T %>% 
    group_by(region) %>%
    summarise(N=n(), tau=sum(population)))

# Nombre d'unites connu
# estimateur de la population par pays
(y.G = sum(sommaire.T$tau)/sum(sommaire.T$N))

# estimateur de la population de la planete
(tau.G = N*y.G)

# calcul de la marge d'erreur sur l'estimation
s2.G =  1/(m-1)*sum((sommaire.T$tau-y.G*sommaire.T$N)^2)
V = M^2*s2.G/m*(1-m/M)
(B = 2*sqrt(V))

# I.C. a environ 95%
c(tau.G-B,tau.G+B)

# Nombre d'unites inconnu
# estimateur de la population par grappe
(y.T = sum(sommaire.T$tau)/m)

# estimateur de la population de la planete
(tau.T = M*y.T)

# calcul de la marge d'erreur sur l'estimation
s2.T =  1/(m-1)*sum((sommaire.T$tau-y.T)^2)
V = M^2*s2.T/m*(1-m/M)
(B = 2*sqrt(V))

# I.C. a environ 95%
c(tau.G-B,tau.G+B)

#### Proportion, esperance de vie > 75

gapminder.EPG <- gapminder %>% 
  filter(year==2011) %>%
  select(life_expectancy, region)

gapminder.EPG$life.75 <- ifelse(gapminder.EPG$life_expectancy>75,1,0)
gapminder.EPG.75 <- gapminder.EPG %>% select(life.75,region)
(mean(gapminder.EPG.75$life.75))

sommaire.75 = gapminder.EPG.75 %>% 
  group_by(region) %>%
  summarise(N=n(), p.hat=mean(life.75))

ggplot(data=sommaire.75, aes(x=p.hat, y=region, size=N, fill=p.hat)) +
  geom_point(col="black", alpha=.2,pch=22) + 
  theme(legend.title = element_blank(), legend.position="none")

regions = unique(gapminder.EPG[,"region"])

# Premier échantillon
set.seed(0) # replicabilite
M=length(regions)
m=8
(sample.reg = sample(1:M,m, replace=FALSE))
sample.ind = gapminder.EPG$region %in% regions[sample.reg]

(gapminder.EPG.G = gapminder.EPG[sample.ind,])

gapminder.EPG.G$region <- as.factor(gapminder.EPG.G$region)

# statistiques de l'echantillon
(sommaire.75.n = gapminder.EPG.G %>% 
  group_by(region) %>%
  summarise(N=n(), p.hat=mean(life.75)))

# estimateur de la proportion
(p.G = sum(sommaire.75.n$N*sommaire.75.n$p.hat)/sum(sommaire.75.n$N))

# calcul de la marge d'erreur sur l'estimation
# taille moyenne des grappes inconnues
taille.moyenne = sum(sommaire.75.n$N)/m
s2.p.G =  1/(m-1)*sum((sommaire.75.n$N*sommaire.75.n$p.hat-p.G*sommaire.75.n$N)^2)
V = 1/taille.moyenne^2*s2.p.G/m*(1-m/M)
(B = 2*sqrt(V))

# I.C. a environ 95%
c(p.G-B,p.G+B)

# calcul de la marge d'erreur sur l'estimation
# taille moyenne des grappes connues
taille.moyenne = nrow(gapminder.EPG.75)/M
s2.p.G =  1/(m-1)*sum((sommaire.75.n$N*sommaire.75.n$p.hat-p.G*sommaire.75.n$N)^2)
V = 1/taille.moyenne^2*s2.p.G/m*(1-m/M)
(B = 2*sqrt(V))

# I.C. a environ 95%
c(p.G-B,p.G+B)

# Second échantillon
set.seed(1) # replicabilite
M=length(regions)
m=8
(sample.reg = sample(1:M,m, replace=FALSE))
sample.ind = gapminder.EPG$region %in% regions[sample.reg]

(gapminder.EPG.G = gapminder.EPG[sample.ind,])

gapminder.EPG.G$region <- as.factor(gapminder.EPG.G$region)

# statistiques de l'echantillon
(sommaire.75.n = gapminder.EPG.G %>% 
    group_by(region) %>%
    summarise(N=n(), p.hat=mean(life.75)))

# estimateur de la proportion
(p.G = sum(sommaire.75.n$N*sommaire.75.n$p.hat)/sum(sommaire.75.n$N))

# calcul de la marge d'erreur sur l'estimation
# taille moyenne des grappes inconnues
taille.moyenne = sum(sommaire.75.n$N)/m
s2.p.G =  1/(m-1)*sum((sommaire.75.n$N*sommaire.75.n$p.hat-p.G*sommaire.75.n$N)^2)
V = 1/taille.moyenne^2*s2.p.G/m*(1-m/M)
(B = 2*sqrt(V))

# I.C. a environ 95%
c(p.G-B,p.G+B)